// Action script...

// [Initial MovieClip Action of sprite 1]
#initclip 1
function FUIComponentClass()
{
    this.init();
} // End of the function
FUIComponentClass.prototype = new MovieClip();
FUIComponentClass.prototype.init = function ()
{
    this.enable = true;
    this.focused = false;
    this.useHandCursor = false;
    this._accImpl = new Object();
    this._accImpl.stub = true;
    this.styleTable = new Array();
    if (_global.globalStyleFormat == undefined)
    {
        _global.globalStyleFormat = new FStyleFormat();
        globalStyleFormat.isGlobal = true;
        _global._focusControl = new Object();
        _global._focusControl.onSetFocus = function (oldFocus, newFocus)
        {
            oldFocus.myOnKillFocus();
            newFocus.myOnSetFocus();
        };
        Selection.addListener(_global._focusControl);
    } // end if
    if (this._name != undefined)
    {
        this._focusrect = false;
        this.tabEnabled = true;
        this.focusEnabled = true;
        this.tabChildren = false;
        this.tabFocused = true;
        if (this.hostStyle == undefined)
        {
            globalStyleFormat.addListener(this);
        }
        else
        {
            this.styleTable = this.hostStyle;
        } // end else if
        this.deadPreview._visible = false;
        this.deadPreview._width = this.deadPreview._height = 1;
        this.methodTable = new Object();
        this.keyListener = new Object();
        this.keyListener.controller = this;
        this.keyListener.onKeyDown = function ()
        {
            this.controller.myOnKeyDown();
        };
        this.keyListener.onKeyUp = function ()
        {
            this.controller.myOnKeyUp();
        };
        for (var _loc3 in this.styleFormat_prm)
        {
            this.setStyleProperty(_loc3, this.styleFormat_prm[_loc3]);
        } // end of for...in
    } // end if
};
FUIComponentClass.prototype.setEnabled = function (enabledFlag)
{
    this.enable = arguments.length > 0 ? (enabledFlag) : (true);
    this.tabEnabled = this.focusEnabled = enabledFlag;
    if (!this.enable && this.focused)
    {
        Selection.setFocus(undefined);
    } // end if
};
FUIComponentClass.prototype.getEnabled = function ()
{
    return (this.enable);
};
FUIComponentClass.prototype.setSize = function (w, h)
{
    this.width = w;
    this.height = h;
    this.focusRect.removeMovieClip();
};
FUIComponentClass.prototype.setChangeHandler = function (chng, obj)
{
    this.handlerObj = obj == undefined ? (this._parent) : (obj);
    this.changeHandler = chng;
};
FUIComponentClass.prototype.invalidate = function (methodName)
{
    this.methodTable[methodName] = true;
    this.onEnterFrame = this.cleanUI;
};
FUIComponentClass.prototype.cleanUI = function ()
{
    if (this.methodTable.setSize)
    {
        this.setSize(this.width, this.height);
    }
    else
    {
        this.cleanUINotSize();
    } // end else if
    this.methodTable = new Object();
    delete this.onEnterFrame;
};
FUIComponentClass.prototype.cleanUINotSize = function ()
{
    for (var _loc2 in this.methodTable)
    {
        this[_loc2]();
    } // end of for...in
};
FUIComponentClass.prototype.drawRect = function (x, y, w, h)
{
    var _loc4 = this.styleTable.focusRectInner.value;
    var _loc5 = this.styleTable.focusRectOuter.value;
    if (_loc4 == undefined)
    {
        _loc4 = 16777215;
    } // end if
    if (_loc5 == undefined)
    {
        _loc5 = 0;
    } // end if
    this.createEmptyMovieClip("focusRect", 1000);
    this.focusRect.controller = this;
    this.focusRect.lineStyle(1, _loc5);
    this.focusRect.moveTo(x, y);
    this.focusRect.lineTo(x + w, y);
    this.focusRect.lineTo(x + w, y + h);
    this.focusRect.lineTo(x, y + h);
    this.focusRect.lineTo(x, y);
    this.focusRect.lineStyle(1, _loc4);
    this.focusRect.moveTo(x + 1, y + 1);
    this.focusRect.lineTo(x + w - 1, y + 1);
    this.focusRect.lineTo(x + w - 1, y + h - 1);
    this.focusRect.lineTo(x + 1, y + h - 1);
    this.focusRect.lineTo(x + 1, y + 1);
};
FUIComponentClass.prototype.pressFocus = function ()
{
    this.tabFocused = false;
    this.focusRect.removeMovieClip();
    Selection.setFocus(this);
};
FUIComponentClass.prototype.drawFocusRect = function ()
{
    this.drawRect(-2, -2, this.width + 4, this.height + 4);
};
FUIComponentClass.prototype.myOnSetFocus = function ()
{
    this.focused = true;
    Key.addListener(this.keyListener);
    if (this.tabFocused)
    {
        this.drawFocusRect();
    } // end if
};
FUIComponentClass.prototype.myOnKillFocus = function ()
{
    this.tabFocused = true;
    this.focused = false;
    this.focusRect.removeMovieClip();
    Key.removeListener(this.keyListener);
};
FUIComponentClass.prototype.executeCallBack = function ()
{
    this.handlerObj[this.changeHandler](this);
};
FUIComponentClass.prototype.updateStyleProperty = function (styleFormat, propName)
{
    this.setStyleProperty(propName, styleFormat[propName], styleFormat.isGlobal);
};
FUIComponentClass.prototype.setStyleProperty = function (propName, value, isGlobal)
{
    if (value == "")
    {
        return;
    } // end if
    var _loc17 = parseInt(value);
    if (!isNaN(_loc17))
    {
        value = _loc17;
    } // end if
    var _loc16 = arguments.length > 2 ? (isGlobal) : (false);
    if (this.styleTable[propName] == undefined)
    {
        this.styleTable[propName] = new Object();
        this.styleTable[propName].useGlobal = true;
    } // end if
    if (this.styleTable[propName].useGlobal || !_loc16)
    {
        this.styleTable[propName].value = value;
        if (this.setCustomStyleProperty(propName, value))
        {
        }
        else if (propName == "embedFonts")
        {
            this.invalidate("setSize");
        }
        else if (propName.subString(0, 4) == "text")
        {
            if (this.textStyle == undefined)
            {
                this.textStyle = new TextFormat();
            } // end if
            var _loc18 = propName.subString(4, propName.length);
            this.textStyle[_loc18] = value;
            this.invalidate("setSize");
        }
        else
        {
            for (var _loc15 in this.styleTable[propName].coloredMCs)
            {
                var _loc4 = new Color(this.styleTable[propName].coloredMCs[_loc15]);
                if (this.styleTable[propName].value == undefined)
                {
                    var _loc5 = {ra: "100", rb: "0", ga: "100", gb: "0", ba: "100", bb: "0", aa: "100", ab: "0"};
                    _loc4.setTransform(_loc5);
                    continue;
                } // end if
                _loc4.setRGB(value);
            } // end of for...in
        } // end else if
        this.styleTable[propName].useGlobal = _loc16;
    } // end if
};
FUIComponentClass.prototype.registerSkinElement = function (skinMCRef, propName)
{
    if (this.styleTable[propName] == undefined)
    {
        this.styleTable[propName] = new Object();
        this.styleTable[propName].useGlobal = true;
    } // end if
    if (this.styleTable[propName].coloredMCs == undefined)
    {
        this.styleTable[propName].coloredMCs = new Object();
    } // end if
    this.styleTable[propName].coloredMCs[skinMCRef] = skinMCRef;
    if (this.styleTable[propName].value != undefined)
    {
        var _loc4 = new Color(skinMCRef);
        _loc4.setRGB(this.styleTable[propName].value);
    } // end if
};
_global.FStyleFormat = function ()
{
    this.nonStyles = {listeners: true, isGlobal: true, isAStyle: true, addListener: true, removeListener: true, nonStyles: true, applyChanges: true};
    this.listeners = new Object();
    this.isGlobal = false;
    if (arguments.length > 0)
    {
        for (var _loc3 in arguments[0])
        {
            this[_loc3] = arguments[0][_loc3];
        } // end of for...in
    } // end if
};
_global.FStyleFormat.prototype = new Object();
FStyleFormat.prototype.addListener = function ()
{
    for (var _loc3 = 0; _loc3 < arguments.length; ++_loc3)
    {
        var _loc4 = arguments[_loc3];
        this.listeners[arguments[_loc3]] = _loc4;
        for (var _loc5 in this)
        {
            if (this.isAStyle(_loc5))
            {
                _loc4.updateStyleProperty(this, _loc5.toString());
            } // end if
        } // end of for...in
    } // end of for
};
FStyleFormat.prototype.removeListener = function (component)
{
    this.listeners[component] = undefined;
    for (var _loc4 in this)
    {
        if (this.isAStyle(_loc4))
        {
            if (component.styleTable[_loc4].useGlobal == this.isGlobal)
            {
                component.styleTable[_loc4].useGlobal = true;
                var _loc3 = this.isGlobal ? (undefined) : (globalStyleFormat[_loc4]);
                component.setStyleProperty(_loc4, _loc3, true);
            } // end if
        } // end if
    } // end of for...in
};
FStyleFormat.prototype.applyChanges = function ()
{
    var _loc6 = 0;
    for (var _loc5 in this.listeners)
    {
        var _loc3 = this.listeners[_loc5];
        if (arguments.length > 0)
        {
            for (var _loc4 = 0; _loc4 < arguments.length; ++_loc4)
            {
                if (this.isAStyle(arguments[_loc4]))
                {
                    _loc3.updateStyleProperty(this, arguments[_loc4]);
                } // end if
            } // end of for
            continue;
        } // end if
        for (var _loc4 in this)
        {
            if (this.isAStyle(_loc4))
            {
                _loc3.updateStyleProperty(this, _loc4.toString());
            } // end if
        } // end of for...in
    } // end of for...in
};
FStyleFormat.prototype.isAStyle = function (name)
{
    return (this.nonStyles[name] ? (false) : (true));
};
#endinitclip

// [Action in Frame 1]
