// Action script...

// [Action in Frame 1]
function thing_init(new_id, cat, type, max_hp, max_shield)
{
    name_tf._visible = false;
    descr_tf._visible = false;
    sel_mc._visible = false;
    this.category = cat;
    this.objtype = type;
    this.id = new_id;
    if (cat == _root.LOG_CAT_SOLDIER)
    {
        log_s_info = _root.LOG_STYPE[type];
        if (log_s_info[0] == "G")
        {
            this.sprite_mc.attachMovie("gdi_soldier", "sprite_mc", sprite_mc.getDepth());
            this.gdi = true;
        }
        else
        {
            this.sprite_mc.attachMovie("nod_soldier", "sprite_mc", sprite_mc.getDepth());
            this.gdi = false;
        } // end else if
    }
    else if (cat == _root.LOG_CAT_VEHICLE)
    {
        log_v_info = _root.LOG_VTYPE[type];
        this.sprite_mc.attachMovie(log_v_info[2], "sprite_mc", sprite_mc.getDepth());
        this.gdi = log_v_info[0] == "G";
        this.update_vdescr();
        this.name_tf.text = log_v_info[1];
    }
    else if (cat == _root.LOG_CAT_OBJECT)
    {
        this.name_tf.text = _root.LOG_OTYPE[type];
        if (type == _root.LOG_OTYPE_TIMED)
        {
            this.sprite_mc.attachMovie("c4_timed", "sprite_mc", sprite_mc.getDepth());
        }
        else if (type == _root.LOG_OTYPE_ION)
        {
            this.sprite_mc.attachMovie("beacon", "sprite_mc", sprite_mc.getDepth());
        }
        else if (type == _root.LOG_OTYPE_NUKE)
        {
            this.sprite_mc.attachMovie("beacon", "sprite_mc", sprite_mc.getDepth());
        } // end else if
    } // end else if
    if (sprite_mc._width > sprite_mc._height)
    {
        sel_mc._width = sprite_mc._width + 4;
    }
    else
    {
        sel_mc._width = sprite_mc._height + 4;
    } // end else if
    sel_mc._height = sel_mc._width + 3;
    var _loc5 = Number(max_hp) + Number(max_shield);
    sel_mc.health_bar_mc.set_hp(_loc5);
    sel_mc.health_bar_mc.set_hp_max(_loc5);
    sel_mc._alpha = 70;
    if (this.gdi)
    {
        this.name_tf.textColor = 16776960;
        this.descr_tf.textColor = 16776960;
    }
    else
    {
        this.name_tf.textColor = 16711680;
        this.descr_tf.textColor = 16711680;
    } // end else if
} // End of the function
function update_vdescr()
{
    if (this.objtype == _root.LOG_VTYPE_GDI_HARVY || this.objtype == _root.LOG_VTYPE_NOD_HARVY)
    {
        if (this.gdi)
        {
            this.name_tf.textColor = 16776960;
        }
        else
        {
            this.name_tf.textColor = 16711680;
        } // end else if
        this.descr_tf.text = "";
        return;
    } // end if
    if (this.driver)
    {
        if (this.driver.gdi)
        {
            col = 16776960;
        }
        else
        {
            col = 16711680;
        } // end else if
    }
    else
    {
        col = 16777215;
    } // end else if
    this.name_tf.textColor = col;
    this.descr_tf.textColor = col;
    if (this.driver)
    {
        this.descr_tf.text = this.driver.player_name + "\n";
    }
    else
    {
        this.descr_tf.text = "(no driver)\n";
    } // end else if
    if (this.passengers.length)
    {
        this.descr_tf.text = this.descr_tf.text + ("(" + this.passengers[0].player_name);
        for (p = 1; p < this.passengers.length; p++)
        {
            this.descr_tf.text = this.descr_tf.text + (", " + this.passengers[p].player_name);
        } // end of for
        this.descr_tf.text = this.descr_tf.text + ")";
    } // end if
} // End of the function
function teleport(x, y)
{
    this._x = x;
    this._y = y;
    this.target_x = x;
    this.target_y = y;
} // End of the function
function move_to(x, y)
{
    if (_root.playspeed == 0)
    {
        return;
    } // end if
    this.playspeed = _root.playspeed;
    this.target_x = x;
    this.target_y = y;
    this.steps = _root.interval_time * 2;
    xdiff = this.target_x - this._x;
    ydiff = this.target_y - this._y;
    this.x_step = xdiff / this.steps;
    this.y_step = ydiff / this.steps;
    if (this.category != _root.LOG_CAT_SOLDIER)
    {
        new_rot = Math.atan2(ydiff, xdiff) / 3.141593E+000 * 180;
        if (_root.playspeed > 0)
        {
            this.sprite_mc._rotation = 90 + new_rot;
        }
        else
        {
            this.sprite_mc._rotation = 270 + new_rot;
        } // end if
    } // end else if
} // End of the function
function update_speed()
{
    factor = _root.playspeed / this.playspeed;
    this.x_step = this.x_step * factor;
    this.y_step = this.y_step * factor;
    this.playspeed = _root.playspeed;
} // End of the function
var id;
var target_x = 0;
var target_y = 0;
var pass = 0;
var track_me = false;
var mouseover = false;
var category = "";
var objtype = "";
var fighting = 0;
var vehicle = false;
var destroyed = false;
var gdi;
onEnterFrame = function ()
{
    if (this._visible && this.destroyed && this.fighting == 0)
    {
        if (this.category == _root.LOG_CAT_VEHICLE && this.killed)
        {
            _root.do_explosion(this._x, this._y, 20, 0);
        }
        else if (this.objtype == _root.LOG_OTYPE_TIMED && !this.killed)
        {
            _root.do_explosion(this._x, this._y, 15, 0);
        }
        else if (this.objtype == _root.LOG_OTYPE_ION && !this.killed)
        {
            _root.do_explosion(this._x, this._y, 15, 1);
        }
        else if (this.objtype == _root.LOG_OTYPE_NUKE && !this.killed)
        {
            _root.do_explosion(this._x, this._y, 15, 2);
        } // end else if
        this._visible = false;
    } // end if
    if (!this._visible)
    {
        return;
    } // end if
    name_tf._visible = _root.show_names >= 1 | this.track_me | this.mouseover | this.pass > 0;
    descr_tf._visible = _root.show_names >= 2 | this.track_me | this.mouseover | this.pass > 0;
    sel_mc._visible = _root.show_hp | this.track_me | this.mouseover | this.pass > 0;
    if (_root.playspeed == 0)
    {
        return;
    } // end if
    if (this.steps > 0)
    {
        if (_root.playspeed != this.playspeed)
        {
            update_speed();
        } // end if
        this._x = this._x + this.x_step;
        this._y = this._y + this.y_step;
        --this.steps;
    } // end if
    if (this.objtype == _root.LOG_VTYPE_NOD_STEALTH || this.objtype == _root.LOG_STYPE_NOD_SBH)
    {
        if ((this.objtype == _root.LOG_STYPE_NOD_SBH || this.driver) && _root.ri - this.last_shot[this.last_shot.length - 1] > 10)
        {
            this.sprite_mc._alpha = 20;
        }
        else
        {
            this.sprite_mc._alpha = 100;
        } // end if
    } // end else if
    this.unit_sel_mc._x = this._x;
    this.unit_sel_mc._y = this._y;
};
sprite_mc.onRelease = function ()
{
    this._parent.track_me = !this._parent.track_me;
    this._parent.sel_mc._alpha = 170 - this._parent.sel_mc._alpha;
};
sprite_mc.onRollOver = function ()
{
    this._parent.mouseover = true;
    _root.mouse_mc._visible = true;
    _root.mouse_mc.gotoAndPlay(2);
    Mouse.hide();
};
sprite_mc.onRollOut = function ()
{
    this._parent.mouseover = false;
    _root.mouse_mc.gotoAndPlay(1);
};
